#ifndef EX13_7_H
#define EX13_7_H

#include <iostream>

template <typename U> void swap(U& a,U& b)
{
    U temp;
    temp = a;
    a = b;
    b = temp;
}

template <typename T> void sort(T* a,int size)
{
    int i,j;
    for (i = 1; i < size; i++)
        for (j = 0; j < i; j++)
            if ( a[i] < a[j] ) swap(a[i],a[j]);
}

template <typename V> void arrayPrint(const V* a,int size)
{
    int i;
    for (i = 0; i < size; i++) std::cout << a[i] << std::endl;
    std::cout << std::endl;
}

#endif
